/************************************************************************************************ 
	Double Precision Calculator
   	Programmed by Chardy
   	version 0.9 -- still testing...
   	support jdk 1.18 and jdk 1.2
   	e-mail chardy_wang@hotmail.com

	"Sharing idea makes us powerful, If you don't share your ideas and ideals,
	they will wind up being worthless"
	
	Theory behind this simple program:

	--> it use java double primitive type to represent number.
	    floating point numbers can takes any of the following value:
		- negative invinity
		- negative, finite value
		- negative zero
		- positive zero
		- positive, finite value
		- positive invinity
		- NaN or "Not a Number
	    So this program can handle any error occur in math problem

	--> it apply and calculate exactly follow mathematical order and priority
	    eg. multiplication and division have higher priority than adition and
	        subtraction operation
	    eg. 2+3*2=8 not 2+3*2=10

************************************************************************************************/   

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;

class CalcPanel extends Panel implements ActionListener
{  
	public CalcPanel()
	{
		setLayout(new BorderLayout());
      		buttonfont = new Font( "Courier", Font.PLAIN, 12 );
		sysClipboard = Toolkit.getDefaultToolkit().getSystemClipboard();		
		display = new TextField("0");
		display.setEditable(false);
		add(display, "North");
		display.setFont (new Font("Courier", 0, 14));
		Panel p = new Panel();
		p.setBackground(Color.yellow);
		CheckboxGroup cbg = new CheckboxGroup();
		p.setLayout(new FlowLayout());
		String[] buttons ={" 1/x"," log","ln","PI",
				   " sin"," cos","tg","\u221A ",
				   " x^y"," rnd","x!","x\u00B2",
				   "7","8","9","DEL"," C ",
    				   "4","5","6"," \u00D7 "," \u00F7 ",
    				   "1","2","3"," + "," - ",
    				   "0",".","E","Abs"," = "}; 
		
		p.add(degree = new Checkbox("Degree", cbg, true));
		p.add(radian = new Checkbox("Radian", cbg, false));
		addButton(p,"Copy Scr",20);
		addButton(p,"Paste Scr",20);
		for ( int i = 0; i < buttons.length; i++ ) 
			addButton(p,buttons[i],i);
		
            	add(p);
	}

	private void addButton(Container c, String s, int i)
	{  
		Button b = new Button(s);
      		b.setFont(buttonfont);
		if (i>=0 && i<12)
		{
			b.setBackground (Color.green);
			b.setForeground (Color.blue);
		} 
		else if (i==15||i==16)
		{
			b.setBackground (Color.black);
			b.setForeground (Color.red);
		}
		else if (i==20||i==21||i==25||i==26||i==30||i==31)
		{
			b.setBackground (Color.gray);
			b.setForeground (Color.green);
		}
		else
		{
			b.setBackground (Color.pink);
			b.setForeground (Color.blue);
		}
		c.add(b);
      		b.addActionListener(this);
		
   	}
	
	public void actionPerformed(ActionEvent evt)
   	{  
		String s = evt.getActionCommand();
		if (degree.getState())
		{
			deg = true;
			rad = false;
		}
		else if (radian.getState())
		{
			rad = true;
			deg = false;
		}
		
      		if (s.equals("Copy Scr")) copy();
		
		if (s.equals("Paste Scr")) 
		{
			paste();
			start = false;
		}
      			
		else if ('0' <= s.charAt(0) && s.charAt(0) <= '9'|| s.equals("."))
         	{  
			if (start) 
			{
				display.setText(s);
				count++;
			}
         		else 
			{
				display.setText(display.getText() + s);
				count++;
			}
			temp[count] = display.getText();
         		start = false;
      		}
      		else if (s.equals("DEL"))
		{
			if(count>1)
			{
				display.setText("" + temp[count-1]);
				count--;
			}
			else 
			{
				temp[1] = "0";
				display.setText("" + temp[1]);
				count = 0;
			}
			start = false;
		}
		else if (s.equals(" C ")) 
			clearScreen();
		
		else if (s.equals("PI")) 
		{
			display.setText("" + Math.PI);
			start = false;
		}
		else if (s.equals("E")) 
		{
			display.setText("" + Math.E);
			start = false;
		}
		else if (s.equals("Abs")||s.equals("\u221A ")||s.equals(" sin")||
			 s.equals(" cos")||s.equals("tg")||s.equals(" log")||
			 s.equals("ln")||s.equals("x!")||s.equals(" 1/x")||
			 s.equals(" rnd")||s.equals("x\u00B2"))
		{	
			double y = Double.valueOf(display.getText()).doubleValue();
			calculate(y,s);
			start = false;
		}
		else 
      		{  
			if (start)
         		{
				if (s.equals(" - ")) 
            			{ 
					display.setText(s.substring(1,2)); start = false; 
					count++;
					temp[count] = display.getText();
				}
            			else op = s;
			}
         		else 
         		{  
				double x = Double.valueOf(display.getText()).doubleValue();
            			
				if (first_do)
				{
					first_do = false;
					calculate(x,op1);
					x = Double.valueOf(display.getText()).doubleValue();					
				}			
				
				if (s.equals(" \u00D7 ")||s.equals(" \u00F7 ")||s.equals(" x^y"))
				{
					first_do = true;
					arg1 = x;
					op1 = s;					
				}
				else	
				{
					calculate(x);
					op = s;					
				}
				start = true;
			}
      		}
	}
   	
	public void clearScreen()
	{
		arg = 0;
		arg1 = 0;
		count = 0;
		op = " = ";
		op1 = " = ";
		start = true;
		first_do = false;
		display.setText("" + arg);
	}

   	public void calculate(double n)
   	{  
		if (op.equals(" + ")) arg += n;
      		else if (op.equals(" - ")) arg -= n;
		else if (op.equals(" \u00D7 ")) arg *= n;
      		else if (op.equals(" \u00F7 ")) arg /= n;
      		else if (op.equals(" = ")) arg = n;
		display.setText("" + arg);
   	}
	
	public void calculate(double m,String a)
   	{
		if (a.equals(" \u00D7 ")) arg1 *= m;
      		else if (a.equals(" \u00F7 ")) arg1 /= m;
		else if (a.equals(" x^y")) arg1 = Math.pow(arg1,m);
		else if (a.equals("Abs")) arg1 = Math.abs(m);
      		else if (a.equals("\u221A ")) arg1 = Math.sqrt(m);
		else if (a.equals(" sin")) 
		{
			if (deg==true)
				arg1 = Math.sin(Math.PI*m/180);
			else if (rad==true)
				arg1 = Math.sin(m);
		}
		else if (a.equals(" cos"))
		{
			if (deg==true)
				arg1 = Math.cos(Math.PI*m/180);
			else if (rad==true)
				arg1 = Math.cos(m);
		}
		else if (a.equals("tg"))
		{
			if (deg==true)
				arg1 = Math.tan(Math.PI*m/180);
			else if (rad==true)
				arg1 = Math.tan(m);
		}
		else if (a.equals(" log")) arg1 = Math.log(m)/Math.log(10);
		else if (a.equals("ln")) arg1 = Math.log(m);
		else if (a.equals(" rnd")) arg1 = Math.round(m);
		else if (a.equals("x!")) arg1 = factorial(m);
		else if (a.equals(" 1/x")) arg1 = reciprocal(m);
		else if (a.equals("x\u00B2")) arg1 = Math.pow(m,2);
		
		display.setText("" + arg1);
		
	}
  	
	public double factorial(double num)
	{
		int Num=(int)num,Fac=1;
		if (Num<0)
		{	
			clearScreen();
			return 0;
		}
		else
		{
			for(int x=1;x<=Num;x++)
				Fac*=x;
			return Fac;
		}
	}

	public double reciprocal(double num) 
	{
		
			return 1/num;
	}

	public void copy()
   	{  
		String text = display.getText();
      		if (text.equals("")) text = display.getText();
      		StringSelection selection = new StringSelection(text);
      		sysClipboard.setContents(selection, null);
   	}
		
	public void paste()
   	{  
		String text;
      		Transferable contents = sysClipboard.getContents(this);
      		if (contents == null) return;
      		try
      		{  
			text = (String)(contents.getTransferData(DataFlavor.stringFlavor));
			display.setText(text);
      		}
      		catch(Exception e)
      		{  
			display.setText("Error: " + e);
      		}
   	}

	private Font buttonfont;
	private Clipboard sysClipboard;
	private TextField display;
	private Checkbox degree, radian;
   	private int count = 0;
	private double arg = 0, arg1 = 0;
  	private String op = " = ", op1 = " = ";
	private String[] temp = new String[100];
	private boolean deg = true, start = true;
	private boolean rad = false, first_do = false;

}

class CalculatorFrame extends Frame implements ActionListener
{  
	public CalculatorFrame()
   	{	  
		setTitle("Calculator");
      		setSize(190, 320);
      		addWindowListener(new WindowAdapter()
         	{  
			public void windowClosing(WindowEvent e)
            		{  
				System.exit(0);
            		}
         	} );
		
		add(new CalcPanel());
		   		
		MenuBar mbar = new MenuBar();
      		setMenuBar(mbar);
		Menu fileMenu = new Menu("File");
      		mbar.add(fileMenu);
      		aboutItem = new MenuItem("About");
      		aboutItem.addActionListener(this);
      		fileMenu.add(aboutItem);
      		exitItem = new MenuItem("Exit");
      		exitItem.addActionListener(this);
      		fileMenu.add(exitItem);
   	}

   	public void actionPerformed(ActionEvent evt)
   	{  
		Object source = evt.getSource();
      		if(source == aboutItem)
      		{  
			if (dialog == null) // first time
            			dialog = new AboutDialog(this);   
         		dialog.show();
      		}
      		else if(source == exitItem)
      		{  
			System.exit(0);
      		}
   	}
   
   	private AboutDialog dialog;
   	private MenuItem aboutItem;
   	private MenuItem exitItem;
}

class AboutDialog extends Dialog
{  
	public AboutDialog(Frame parent)
   	{  
		super(parent, "About", true);         
		Panel p1 = new Panel();
      		p1.setFont (new Font("Courier", 0, 10));
		p1.setBackground (Color.yellow);
      		p1.add(new Label("Double Precision Calculator"));
		p1.add(new Label("version 0.9 testing [jdk 1.18 & 1.2]"));
      		p1.add(new Label("Programmed by : Chardy",Label.LEFT));
		p1.add(new Label("e-mail: chardy_wang@hotmail.com",Label.LEFT));
		add(p1);
                Panel p2 = new Panel();
		p2.setBackground (Color.yellow);
      		Button ok = new Button("Ok");
		ok.setBackground (Color.gray);
		ok.setForeground (Color.green);
      		p2.add(ok);
      		add(p2, "South");
      		ok.addActionListener(new ActionListener() 
         	{  
			public void actionPerformed(ActionEvent evt) 
            		{ 
				setVisible(false); 
			} 
         	} );

      		setSize(250, 170);
   	}
}

           
public class Calculator2
{  
	public static void main(String[] args)
   	{  
		Frame frame = new CalculatorFrame();
      		frame.show();  
   	}
}

